<script setup lang="ts">
import { useDataStore } from '@/store/data'
import { blockchainNodes, primaryBackends } from '@/scripts/embeddedConfig'
import { reactive } from 'vue'
import { useAppStore } from '@/store/app'
import { useSessionStore } from '@/store/session'

const data = useDataStore()
const app = useAppStore()
const session = useSessionStore()

const primaryBackendsList = primaryBackends()
const blockchainNodesList = blockchainNodes()

const state = reactive({
  debug: localStorage.getItem('debug') != null,
  sessionOverride: '',
  localStorageSession: localStorage.getItem('session'),
  localStorageTicket: localStorage.getItem('ticket')
})

function enableDebug () {
  localStorage.setItem('debug', 'true')
  state.debug = true
  window.location.reload()
}

function disableDebug () {
  localStorage.removeItem('debug')
  state.debug = false
  window.location.reload()
}

function getCurrentSession() {
  const session = localStorage.getItem('session')
  if (session == null) {
    app.notification('error', 'No session stored in localStorage !')
    return
  }
  state.sessionOverride = session
  if (navigator.clipboard == null) {
    app.notification('error', 'Unable to use the clipboard')
  }
  navigator.clipboard.writeText(session).then(() => {
    app.notification('success', 'Session saved to clipboard')
  }).catch((err: unknown) => {
    console.error(err)
    app.notification('error', 'Unable to save the session to the clipboard. Check the console')
  })
}

function loadSessionFromClipboard() {
  if (navigator.clipboard == null) {
    app.notification('error', 'Unable to use the clipboard')
  }
  navigator.clipboard.readText().then(text => {
    state.sessionOverride = text
    applySession()
  }).catch((err) => {
    console.error(err)
    app.notification('error', 'Unable to load the session from the clipboard. Check the console')
  })
}

function applySession() {
  if (state.sessionOverride.length === 0) return
  localStorage.setItem('session', state.sessionOverride)
  app.notification('success', 'Session applied')
  setTimeout(() => {
    window.location.reload()
  }, 500)
}

function localStorageReset(what: 'all' | 'session' | 'ticket') {
  switch (what) {
    case 'all':
      localStorage.clear()
      break
    case 'session':
      localStorage.removeItem('session')
      break
    case 'ticket':
      localStorage.removeItem('ticket')
      break
  }
  window.location.reload()
}
</script>

<template>
  <div class="flex flex-col px-3 max-w-2xl mx-auto ">
    <section class="mb-4">
      <h1 class="text-2xl font-bold mb-3">Paramètres</h1>
      <h4 class="text-md">Cette page vous permet d'ajuster vos préférences et affiche quelques informations techniques</h4>
    </section>

    <v-card class="mb-4">
      <v-card-title>Sélection du nœud de blockchain</v-card-title>
      <v-card-text>
        <v-select :model-value="data.blockchainNode.name" :items="blockchainNodesList" item-title="name" @update:model-value="v => data.setBackend('blockchain', v)"/>
        <p>Blockchain URL: {{ data.blockchainNode.blockchainNodeUrl }}</p>
        <v-btn class="mt-3" variant="outlined" block target="_blank" :href="`https://polkadot.js.org/apps/?rpc=${encodeURI(data.blockchainNode.blockchainNodeUrl || '')}`">Voir la blockchain en live</v-btn>
      </v-card-text>
    </v-card>

    <div v-if="state.debug">
      <div class="flex justify-between items-center mb-4">
        <h2 class="text-xl font-xl">Debug Section</h2>
        <v-btn variant="outlined" size="x-small" @click="disableDebug">Disable debug mode</v-btn>
      </div>

      <v-card class="mb-4">
        <v-card-title>Sélection du backend primaire</v-card-title>
        <v-card-text>
          <v-select :model-value="data.primaryBackend.name" :items="primaryBackendsList" item-title="name" @update:model-value="v => data.setBackend('primary', v)"/>
          <p>Backend URL: {{ data.primaryBackend.backendUrl }}</p>
        </v-card-text>
      </v-card>

      <v-card class="mb-4">
        <v-card-title>Session override</v-card-title>
        <v-card-text>
          <div class="flex">
            <v-text-field v-model="state.sessionOverride" placeholder="Paste the session override"/>
            <v-btn class="ml-3" round icon="mdi-content-save" @click="applySession"/>
          </div>
          <div class="flex flex-col">
            <v-btn class="my-3" @click="session.clearSession">Clear session & reload</v-btn>
            <v-btn class="my-3" @click="getCurrentSession">Get current session</v-btn>
            <v-btn class="my-3" @click="loadSessionFromClipboard">Paste & load session</v-btn>
          </div>
        </v-card-text>
      </v-card>

      <v-card class="mb-4">
        <v-card-title>Local storage</v-card-title>
        <v-card-text class="flex flex-col">
          <div class="flex flex-col">
            <v-btn class="my-3" @click="localStorageReset('session')">Reset session</v-btn>
            <v-btn class="my-3" @click="localStorageReset('ticket')">Reset ticket</v-btn>
            <v-btn class="my-3" @click="localStorageReset('all')">Reset all</v-btn>
          </div>
          <div class="flex flex-col">
            <h4 class="text-center">LS Ticket</h4>
            <p>{{ state.localStorageTicket || 'No ticket stored' }}</p>
            <h4 class="text-center">LS Session</h4>
            <p>{{ state.localStorageSession || 'No session stored' }}</p>
          </div>
        </v-card-text>
      </v-card>

    </div>
    <div v-else class="my-5 flex flex-col">
      <v-btn variant="text" size="x-small" color="grey" @click="enableDebug">( Enable debug mode )</v-btn>
    </div>
  </div>
</template>
